/*
	dropsie.c - drop all chars on the screen to the bottom.

		This is the practical joke version of DROP.C
		The command line is erased, then the screen
		isn't dropped until the victim presses a key.
		Pressing a key while DROPSIE is working or
		after it's finished will restore the original
		screen.

		An optional integer argument on the command
		line changes the default fall rate.
			(0 = fastest, 100 = slow)

		ver 1.0		gjpateman	11/20/89
*/

#define	WIDTH	80

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>

void main(int argc, char *argv[])
{
	int	x, y, i,		/* loop counters */
		wait=5,			/* set default falling speed */
		top[WIDTH+1];		/* character stacks at bottom */
	char    c[2],			/* current char & attribute */
		scrn[WIDTH*25*2];	/* used to restore screen */
	struct text_info  scrn_info;	/* used to restore screen */


	if(argc>1)
		wait=atoi(argv[1]);	/* change falling rate to arg #1 */

	gotoxy(1,wherey()-1);		/* erase DROPSIE command line */
	clreol();

	gettext(1,1,80,25,scrn);        /* store screen */
	gettextinfo(&scrn_info);

	for(x=1;x<=80;x++)		/* initialize each heap */
		top[x]=24;

	_AH=0x01;			/* turn cursor off */
	_CH=0x20;
	geninterrupt(0x10);

	while(kbhit())	getch();	/* clear the keyboard buffer */
	getch();			/* wait for any key */

	for(y=24;y>=1;y--)		/* lines 24 to 1 */
		for(x=80;x>=1;x--)	/* characters 80 to 1 */
			{
			gettext(x,y,x,y,c);	/* store char/attrib in 'c' */
			if(c[0]!=0x20)
				{
				for(i=y;i<=top[x];i++)	/* drop it */
					{
					puttext(x,i,x,i,c);
					gotoxy(x,i);
					delay(wait);
					putch(' ');
					}
				puttext(x,i,x,i,c);
				--top[x];	/* heap is 1 char taller now */

				if(kbhit())	/* aborting? */
					{
					x=1;
					y=1;
					}
				}
			}

	getch();	/* wait for keypressed before exiting */

	_AH = 0x01;			/* turn cursor back on */
	_CH = 6;
	_CL = 7;
	geninterrupt(0x10);

	puttext(1,1,80,25,scrn);	/* return original screen */
	gotoxy(scrn_info.curx,scrn_info.cury);
}

